'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: November 21, 2003
'Last Updated: December 7, 2008
'=============================================

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private Pos As PointF
    Private FOV, HalfFOV, ViewDist, Angle, Speed As Integer
    Private Sectors(7) As Integer

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
        Me.Text = "Form1"
        Me.WindowState = FormWindowState.Maximized
    End Sub

#End Region


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim idx As Integer

        DoReset()
        For idx = 0 To 7
            Sectors(idx) = idx * 45
        Next
    End Sub

    Private Sub DoReset()
        Pos = New PointF(CSng(Me.ClientSize.Width / 2), CSng(Me.ClientSize.Height / 2))
        FOV = 90
        HalfFOV = FOV \ 2
        ViewDist = 100
        Speed = 10
        Angle = 270
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Dim P As Pen
        Dim Pts(2), Pt As PointF
        Dim B As Brush

        e.Graphics.Clear(Me.BackColor)

        ' create points
        Pts(0) = Pos
        Pts(1) = New PointF(CSng(Math.Cos(DegreeToRadian(Angle - HalfFOV)) * ViewDist) + Pos.X, _
                            CSng(Math.Sin(DegreeToRadian(Angle - HalfFOV)) * ViewDist) + Pos.Y)
        Pts(2) = New PointF(CSng(Math.Cos(DegreeToRadian(Angle + HalfFOV)) * ViewDist) + Pos.X, _
                            CSng(Math.Sin(DegreeToRadian(Angle + HalfFOV)) * ViewDist) + Pos.Y)

        P = New Pen(Color.Green)
        e.Graphics.DrawEllipse(P, Pos.X - 5, Pos.Y - 5, 10, 10)

        Pt = GetNextPos()
        P = New Pen(Color.Red)
        e.Graphics.DrawEllipse(P, Pt.X - 5, Pt.Y - 5, 10, 10)

        P = New Pen(Color.Black)
        e.Graphics.DrawLine(P, Pos, Pt)

        ' draw view
        B = New SolidBrush(Color.FromArgb(128, 64, 128, 255))
        e.Graphics.FillPolygon(B, Pts)

        DrawWhatYouSee(e.Graphics)

        e.Graphics.DrawString("Left/Right change direction {hold control for speed}" & vbCrLf & _
                              "Up/Down Moves forward back" & vbCrLf & _
                              "R resets" & vbCrLf & _
                              "Q/W Change field of view {hold control for speed}" & vbCrLf & _
                              "Z/A Change vide distance {hold control for speed}" & vbCrLf & _
                              "X/S Change speed {hold control for speed}" & vbCrLf & _
                              "Escape quits", Me.Font, Brushes.Black, 10, 10)
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Left
                If e.Control Then Angle -= 10 Else Angle -= 1
                If Angle < 0 Then Angle = 360 - Math.Abs(Angle)

            Case Keys.Right
                If e.Control Then Angle += 10 Else Angle += 1
                If Angle > 359 Then Angle = Angle - 360

            Case Keys.Down
                Pos = GetNextPos(True)

            Case Keys.Up
                Pos = GetNextPos()

            Case Keys.R
                DoReset()

            Case Keys.Q
                If e.Control Then FOV -= 10 Else FOV -= 1
                If FOV < 1 Then FOV = 1
                HalfFOV = FOV \ 2

            Case Keys.W
                If e.Control Then FOV += 10 Else FOV += 1
                If FOV > 359 Then FOV = 359
                HalfFOV = FOV \ 2

            Case Keys.Z
                If e.Control Then ViewDist -= 10 Else ViewDist -= 1
                If ViewDist < 1 Then ViewDist = 1

            Case Keys.A
                If e.Control Then ViewDist += 10 Else ViewDist += 1
                If ViewDist > 600 Then ViewDist = 600

            Case Keys.X
                If e.Control Then Speed -= 10 Else Speed -= 1
                If Speed < 1 Then Speed = 1

            Case Keys.S
                If e.Control Then Speed += 10 Else Speed += 1
                If Speed > 600 Then Speed = 600

            Case Keys.Escape
                Me.Close()
        End Select

        Me.Refresh()
    End Sub

    ' If you are going to use this method in a game be sure to 
    ' precompute the sin and cos tables from 0 to 359 etc.
    Public Function GetNextPos(Optional ByVal Backwards As Boolean = False) As PointF
        Dim P As New PointF()

        P.X = CSng(Math.Cos(DegreeToRadian(Angle)) * Speed)
        P.Y = CSng(Math.Sin(DegreeToRadian(Angle)) * Speed)

        If Backwards Then
            Return New PointF(Pos.X - P.X, Pos.Y - P.Y)
        Else
            Return New PointF(Pos.X + P.X, Pos.Y + P.Y)
        End If
    End Function

    Private Sub DrawWhatYouSee(ByVal G As Graphics)
        Dim P As Pen
        Dim LAngle, RAngle As Integer
        Dim S1, S2 As Integer
        Dim Pts(2), Pt As PointF
        Dim idx As Integer


        P = New Pen(Color.Black)
        LAngle = Angle - HalfFOV
        RAngle = Angle + HalfFOV
        If LAngle < 0 Then LAngle = 359 - Math.Abs(LAngle)
        If RAngle < 0 Then RAngle = 359 - Math.Abs(RAngle)

        If LAngle > 359 Then LAngle = LAngle - 359
        If RAngle > 359 Then RAngle = RAngle - 359

        S1 = GetSector(LAngle)
        S2 = GetSector(RAngle)

        idx = S1
        While True
            ' create points
            Pts(0) = Pos
            Pts(1) = New PointF(CSng(Math.Cos(DegreeToRadian(idx * 45)) * ViewDist) + Pos.X, _
                                CSng(Math.Sin(DegreeToRadian(idx * 45)) * ViewDist) + Pos.Y)
            Pts(2) = New PointF(CSng(Math.Cos(DegreeToRadian((idx * 45) + 45)) * ViewDist) + Pos.X, _
                                CSng(Math.Sin(DegreeToRadian((idx * 45) + 45)) * ViewDist) + Pos.Y)
            G.DrawPolygon(P, Pts)

            If idx = S2 Then Exit While
            idx += 1
            If idx > 7 Then idx = 0
        End While
    End Sub

    Private Function GetSector(ByVal Value As Integer) As Integer
        Dim idx As Integer

        For idx = 0 To 7
            If Value >= Sectors(idx) And Value <= Sectors(idx) + 45 Then Return idx
        Next

        Return -1
    End Function

    Private Function DegreeToRadian(ByVal value As Integer) As Single
        Return value * 0.01745329F
    End Function
End Class